/***[redirect_cgi.c]**********************************************[TAB=4]****\
*                                                                            *
* NSAPI CGI Redirection Module                                               *
*                                                                            *
* Copyright 1995,1996 Rasmus Lerdorf <rasmus@vex.net>                        *
*                                                                            *
*  This program is free software; you can redistribute it and/or modify      *
*  it under the terms of the GNU General Public License as published by      *
*  the Free Software Foundation; either version 2 of the License, or         *
*  (at your option) any later version.                                       *
*                                                                            *
*  This program is distributed in the hope that it will be useful,           *
*  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
*  GNU General Public License for more details.                              *
*                                                                            *
*  You should have received a copy of the GNU General Public License         *
*  along with this program; if not, write to the Free Software               *
*  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 *
*                                                                            *
\****************************************************************************/
#include "base/pblock.h"
#include "frame/http.h"
#include "frame/log.h"
#include <string.h>

int redirect_cgi(pblock *pb, Session *sn, Request *rq) {
	int l=0, lr=0, lq=0, lc=0;
	char *rpath, *pi;
	pb_param *path = pblock_find("path", rq->vars);
	pb_param *rqpath = pblock_find("uri", rq->reqpb);
	pb_param *query = pblock_find("query", rq->reqpb);
	pb_param *ctype = pblock_find("content-type", rq->srvhdrs);
	char *cgi_path = pblock_findval("cgi_path", pb);
	char *type = pblock_findval("type", pb);

    if(!cgi_path || !type) {
        log_error(LOG_MISCONFIG, "redirect-cgi", sn, rq, 
			"missing parameters (need cgi_path and type)");
		return REQ_ABORTED;
	}
	l = strlen(path->value);
	lr = strlen(rqpath->value);
	if(query) lq = strlen(query->value);
	lc = strlen(cgi_path);
	if(l && !strcmp(ctype->value,type)) {
		rpath = (char *)MALLOC(lc + 1);
		pi = (char *)MALLOC(lr + lq + 1);
		strcpy(rpath,cgi_path);
		if(query) sprintf(pi,"%s?%s",rqpath->value,query->value);
		else strcpy(pi,rqpath->value);
		FREE(path->value);	
		path->value = rpath;	
		FREE(ctype->value);
		ctype->value = STRDUP("magnus-internal/cgi");
		pblock_nvinsert("path-info", pi, rq->vars);
	}
	return REQ_PROCEED;
}
